/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.vostok.management.test;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import org.vostok.management.annotations.LocalDependencies;
import org.vostok.management.annotations.MBean;

/**
 * a simple bean, whish depend on mbean "B", therefore "B" must be deployed before "A"
 *
 * @author levreau.jerome@vostoksystem.eu
 */
@MBean
@LocalDependencies(B.class)
public class A {

	//
	@Resource
	B beanB;
	//
	public String str = "abc";

	public String getStr() {
		return str;
	}

	public String ping(String str) {
		return "Does a ping from A : " + str;
	}

	public void hello() {
		System.out.println("hello world");
	}

	/**
	 * annoted with
	 *
	 * @Started, this method will be called AFTER the bean succesfully load Note : annoation is option
	 */
	@PostConstruct
	public void loading() {
		System.out.println("bean A is running...");
		System.out.println("calling B.ping from A : " + beanB.ping("Hello from A.loading"));
	}

	/**
	 * this method will be called just before removing the mbean from server
	 */
	@PreDestroy
	public void stopping() {
		System.out.println("bean A stopping...");
	}
}
