/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.vostok.management.test;

import javax.management.MBeanRegistrationException;
import javax.management.MBeanServerInvocationHandler;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import org.vostok.management.mbean.DuplicateNameException;
import org.vostok.management.mbean.LocalDependencyException;
import org.vostok.management.mbean.MBeanFactory;
import org.vostok.management.mbean.RunningException;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class VostokMBeanLibSample {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws MBeanRegistrationException, LocalDependencyException, MalformedObjectNameException, DuplicateNameException, RunningException {

		MBeanFactory factory = MBeanFactory.CreateFactory("org.vostok.management.test");

		factory.startAndWait();

		try {
			// this statement is only needed here to prevent overlapping of output messages betteen logger and system.out
			Thread.sleep(3000);
		} catch (InterruptedException ex) {
		}

		try {
			String str;
			System.out.println("Invoking hello method on bean A...");
			factory.getMbeanServer().invoke(new ObjectName(MBeanFactory.getJndi(A.class)), "hello", new Object[]{}, new String[]{});

			System.out.println("##### str : " + factory.getMbeanServer().invoke(new ObjectName(MBeanFactory.getJndi(A.class)), "getStr", new Object[]{}, new String[]{}));

			System.out.println("Invoking ping method on bean A...");
			str = (String) factory.getMbeanServer().invoke(new ObjectName(MBeanFactory.getJndi(A.class)), "ping", new Object[]{"Says hello from test app"}, new String[]{"java.lang.String"});
			System.out.println("... answer from A is \"" + str + "\"");

			try {
				System.out.println("Invoking method \"doesntexit\" method on bean A...");
				str = (String) factory.getMbeanServer().invoke(new ObjectName(MBeanFactory.getJndi(A.class)), "doesntexit", new Object[]{"nothing"}, new String[]{"java.lang.String"});
				System.out.println("--> " + str);
			} catch (Exception e) {
				System.out.println(".... which obviously end in an exeption !");
			}

			System.out.println("Invoking method ping on mbean B using reflexion...");
			str = (String) factory.getMbeanServer().invoke(new ObjectName(MBeanFactory.getJndi(B.class)), "ping", new Object[]{"pour b"}, new String[]{"java.lang.String"});
			System.out.println("... answer from B is \"" + str + "\"");

			System.out.println("Mbean B is a jmx, use proxy...");
			BMBean bean = (BMBean) MBeanServerInvocationHandler.newProxyInstance(factory.getMbeanServer(), new ObjectName(MBeanFactory.getJndi(B.class)), BMBean.class, false);
			System.out.println("... proxy for mbean B created...");
			System.out.println(bean.ping("A ping using proxy instance"));

		} catch (Throwable ex) {
			ex.printStackTrace();
		}

		factory.stop();
	}
}
