/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.vostok.management.test.withinterface;

import javax.management.InstanceNotFoundException;
import javax.management.MBeanException;
import javax.management.MBeanRegistrationException;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.management.ReflectionException;
import org.vostok.management.mbean.DuplicateNameException;
import org.vostok.management.mbean.LocalDependencyException;
import org.vostok.management.mbean.MBeanFactory;
import org.vostok.management.mbean.RunningException;
import org.vostok.management.test.withinterface.server.AService;
import org.vostok.management.test.withinterface.shared.AServicesInterface;

/**
 * this other test show how to register a service with use interface from a different package, typ. shared from server and client
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class TestWithInterfaceAnnotationSample {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws DuplicateNameException, MBeanRegistrationException, RunningException, LocalDependencyException, MalformedObjectNameException, InstanceNotFoundException, MBeanException, ReflectionException {
		MBeanFactory factory = MBeanFactory.CreateFactory("org.vostok.management.test.withinterface.server");

		factory.startAndWait();

		try {
			// this statement is only needed here to prevent overlapping of output messages betteen logger and system.out
			Thread.sleep(3000);
		} catch (InterruptedException ex) {
		}

		String str;

		System.out.println("Invoking ping method using reflexion...");
		System.out.println("##### str : " + factory.getMbeanServer().invoke(new ObjectName(MBeanFactory.getJndi(AService.class)), "ping", new Object[]{"Says hello with reflexion"}, new String[]{"java.lang.String"}));

		System.out.println("... but since we're sharing interface, makes sence to use a proxy...");

		// nota : use of getJndi doe
		AServicesInterface mbean = factory.getMbean(AServicesInterface.class, "bean:org.vostok.management.test.withinterface.server=AServiceService");
		System.out.println("#### str :" + mbean.ping("Now says hello using a proxy"));
	}
}
