package org.vostok.management.test.web.partA;

import java.io.IOException;
import javax.management.MBeanServerInvocationHandler;
import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.vostok.management.mbean.MBeanFactory;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class CalculatorServlet extends HttpServlet {

	/**
	 * Processes requests for both HTTP
	 * <code>GET</code> and
	 * <code>POST</code> methods.
	 *
	 * @param request servlet request
	 * @param response servlet response
	 * @throws ServletException if a servlet-specific error occurs
	 * @throws IOException if an I/O error occurs
	 */
	protected void processRequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html;charset=UTF-8");

		MBeanFactory factory = MBeanFactory.getFactory(); // get factory used to load mbean, i.e. default one

		try {
			String source = request.getParameter("source");

//			Calculator bean = (Calculator) MBeanServerInvocationHandler.newProxyInstance(factory.getMbeanServer(), new ObjectName(MBeanFactory.getJndi(Calculator.class)), Calculator.class, false);
			Calculator bean = (Calculator) factory.getMbean(Calculator.class);

			try {
				request.setAttribute("answer", "answer : " + bean.operation(source));
			} catch (BadFormatException e) {
				request.setAttribute("answer", "expression string is invalid.");
			}
			getServletContext().getRequestDispatcher("/index.jsp").forward(request, response);

		} catch (Exception e) {

			e.printStackTrace();
			response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
		}
	}

	// <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
	/**
	 * Handles the HTTP
	 * <code>GET</code> method.
	 *
	 * @param request servlet request
	 * @param response servlet response
	 * @throws ServletException if a servlet-specific error occurs
	 * @throws IOException if an I/O error occurs
	 */
	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * Handles the HTTP
	 * <code>POST</code> method.
	 *
	 * @param request servlet request
	 * @param response servlet response
	 * @throws ServletException if a servlet-specific error occurs
	 * @throws IOException if an I/O error occurs
	 */
	@Override
	protected void doPost(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * Returns a short description of the servlet.
	 *
	 * @return a String containing servlet description
	 */
	@Override
	public String getServletInfo() {
		return "Short description";
	}// </editor-fold>
}
