/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.vostok.management.test.web.partA;

import java.io.Serializable;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.vostok.management.annotations.MBean;

/**
 * cnovert a string in the form "float operation float" into numbers. Only convert simple operation (full support is not the purpose of this sample !). Part of the VostokMbeanSample pack.
 *
 * @author levreau.jerome@vostoksystem.eu
 */
@MBean // will be used with localInjection by "Calculator"
public class Extract {

	Pattern pattern = Pattern.compile("(\\s*\\d+(?:\\.\\d+)?)\\s*([\\+\\-\\/\\*]?)\\s*(\\d+(?:\\.\\d+)?)\\s*");

	public Item convert(String str) throws BadFormatException {

		try {
			Matcher m = pattern.matcher(str);

			if (m.matches() == false) {
				throw new BadFormatException();
			}

			return new Item(m.group(1), m.group(3), m.group(2));

		} catch (Exception e) {
		}

		throw new BadFormatException();
	}

	public class Item implements Serializable {

		float a;
		float b;
		Operation op;

		protected Item() {
		}

		protected Item(String a, String b, String op) throws BadFormatException {

			this.a = Float.parseFloat(a.trim());
			this.b = Float.parseFloat(b.trim());

			op = op.trim();

			if (op.compareTo("+") == 0) {
				this.op = Operation.ADD;
			} else if (op.compareTo("-") == 0) {
				this.op = Operation.SUB;
			} else if (op.compareTo("/") == 0) {
				this.op = Operation.DIV;
			} else if (op.compareTo("*") == 0) {
				this.op = Operation.MUL;
			} else {
				throw new BadFormatException();
			}
		}

		public float getA() {
			return a;
		}

		public float getB() {
			return b;
		}

		public Operation getOp() {
			return op;
		}

		@Override
		public String toString() {
			return "Item{" + "a=" + a + ", b=" + b + ", op=" + op + '}';
		}
	}

	public enum Operation {

		ADD, SUB, MUL, DIV;
	}
}
